#include <linux16/types.h>
#include <linux16/sched.h>
#include <a.out.h>
#include <arch/system.h>

__u16 cs, cs_size, ds_size; 

void main()
{
#asm
! First, set up ds to 0x1000 (or wherever the kernel is loaded.)
	mov bx, cs
	dec bx
	dec bx
	mov ds, bx
	inc bx
	inc bx
! Load the code segment size and put it in.
	mov ax, [0x8] ! Size of cs in a.out header
	mov cl, #4
	shr ax, cl 
	add bx, ax
	mov es, bx
	eseg
	mov _cs_size, ax
! Now set up the data segment size (.text + .bss)
	mov ax, [0xc]
	add ax, [0x10]
	shr ax, cl 
	eseg 
	mov _ds_size, ax	
! Create the kernel stack area (currently 0x800 bytes)
	add bx, ax
	mov ss, bx
	mov sp, #0x7ff
	mov bx, cs
	eseg
	mov _cs, bx
	push es
	pop ds
#endasm

/* This basically does all of the same things as that code, but sets up the C 
 * equivalents.  This could be cleaned up later. 
 */

	arch_segs.cs = cs;
	arch_segs.cslen = (cs_size);
	arch_segs.ds = arch_segs.cs + arch_segs.cslen;  
	arch_segs.dslen = (ds_size);
	arch_segs.ss = arch_segs.ds + arch_segs.dslen; 
	arch_segs.sslen = 0x80;
	arch_segs.highss = arch_segs.ss;

#asm
	mov ax, ds
	xor bx, bx
	mov ds, bx 
	mov [bx+0x200], #_schedjump
	mov [bx+0x202], cs
!	I hate using interrupt space, but 0x300-0x400 is going to be ts data
	mov [bx+0x300], ax
	mov ds, ax
#endasm
	kernel_main();
}

