/*
 * lbios.rm/rm_mm.c
 * (C) 1995 Chad Page
 *
 * This file (will) contain the basic memory-management routines.  It will
 * handle the initialization, etc.
 */

#include <linux16/types.h> /* Can't forget that one */
#include <linux16/lbios.h> /* Basic LBIOS documentation and headers */
#include <arch/lbiosrm.h>  /* Implementation specific stuff */

/* 
 * At this point, the LBIOS core has already determined which function it's
 * calling, and we don't have to do any processing here.  If things get too
 * convoluted, a two-layer scheme with a switch() system may be a good idea. 
 */

/* 
 * This function sets up the basic MM variables, and the global heap. 
 * The segments have already been defined at this point by rm_init.c
 */
void rm_meminit()
{
	int memsize;
	/* First, figure out where we are.  We can assume that our image is
	  loaded at 0x1000:0, since this is a self-booting VBIOS for now. */

	/* BIOS calls or 0x40:XXXX memory reads here :) */

	/* We use arch_segs.ss in case we eventually get a nice compiler with
	 * SS!=DS capacity and if a future version decides to use that */
	mmheapinfo.lowseg = arch_segs.ss + arch_segs.sslen;
	mmheapinfo.highseg = memsize << 6; /* memsize * (1024 / 16) */	

}

